<?php

/**
 * SMS Gateway handler class
 *
 * @author MesajPaneliSMS
 */
class MesajPaneliSMSGateway {

    private static $_instance;

    public static function init() {
        if (!self::$_instance) {
            self::$_instance = new MesajPaneliSMSGateway();
        }

        return self::$_instance;
    }

    public static function MesajPaneliSendSMS($smsData) {

        $data['msgBaslik'] = mesajpanelisms_get_option('MesajPaneli_originator', 'mesajpanelisms_gateway', '');

        $username = mesajpanelisms_get_option('MesajPaneli_username', 'mesajpanelisms_gateway', '');
        $password = mesajpanelisms_get_option('MesajPaneli_password', 'mesajpanelisms_gateway', '');

        if (empty($username) || empty($password)) {
            return;
        }

        $data['user'] = [ 'name' => $username, 'pass' => $password ];

        $recipient = $smsData['number'];
        $msg       = $smsData['sms_body'];

        $data['msgData'][] = [
            'tel' => $recipient,
            'msg' => $msg
        ];

        $data = "data=" . base64_encode(json_encode($data));

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'http://api.smsvitrini.com/json_api/');
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 120);

        $result   = curl_exec($ch);
        $response = json_decode(base64_decode($result), true);

        if (isset($response['status'])) {
            if ($response['status']) {
                return true;
            }
        }

        return false;
    }

}
